#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct EnumTimeRangeFilterSeriesNode {
    #[builder(custom(type = super::EnumSeriesNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::EnumSeriesNode>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "startTime", skip_serializing_if = "Option::is_none", default)]
    start_time: Option<Box<super::super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "endTime", skip_serializing_if = "Option::is_none", default)]
    end_time: Option<Box<super::super::super::super::super::api::Timestamp>>,
}
impl EnumTimeRangeFilterSeriesNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(input: super::EnumSeriesNode) -> Self {
        Self::builder().input(input).build()
    }
    #[inline]
    pub fn input(&self) -> &super::EnumSeriesNode {
        &*self.input
    }
    #[inline]
    pub fn start_time(
        &self,
    ) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.start_time.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end_time(
        &self,
    ) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.end_time.as_ref().map(|o| &**o)
    }
}
